"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var helpers_1 = require("../helpers");
var BEMNode_1 = require("./BEMNode");
var BEMElement = /** @class */ (function (_super) {
    __extends(BEMElement, _super);
    function BEMElement() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BEMElement.prototype.getNames = function () {
        var _this = this;
        var bemBlock = this.props.bemBlock;
        var BEM_BlockNames = this.context.BEM_BlockNames;
        var setting = this.getBemSetting();
        var elementDelimiter = setting.elementDelimiter;
        var blockNames = bemBlock ? helpers_1.convertBemValueToArray(bemBlock) : BEM_BlockNames;
        var result = [];
        blockNames.forEach(function (blockName) {
            var value = helpers_1.convertBemValueToArray(_this.props.bemName)
                .map(function (name) { return helpers_1.getStringBemInfo(name, setting); })
                .filter(function (info) { return helpers_1.checkBemInfoCondition(info, blockName, ''); })
                .map(function (info) { return "" + blockName + elementDelimiter + info.className; });
            result.push.apply(result, value);
        });
        return result;
    };
    return BEMElement;
}(BEMNode_1.BEMNode));
exports.BEMElement = BEMElement;
