"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var PropTypes = require("prop-types");
var helpers_1 = require("../helpers");
var BEMNode = /** @class */ (function (_super) {
    __extends(BEMNode, _super);
    function BEMNode() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    BEMNode.prototype.getMods = function () {
        return helpers_1.convertBemValueToArray(this.props.bemMod);
    };
    BEMNode.prototype.getNames = function () {
        throw new Error('getNames not implement');
    };
    BEMNode.prototype.getClassName = function () {
        var names = this.getNames();
        var mods = this.getMods();
        var setting = this.getBemSetting();
        var classNames = [];
        names.forEach(function (name) { return classNames.push.apply(classNames, helpers_1.addModifiersToClassName(name, mods, setting)); });
        if (this.props.className) {
            classNames.push(this.props.className);
        }
        return classNames;
    };
    BEMNode.prototype.getBemSetting = function () {
        if (!this.context.BEM_Setting) {
            return helpers_1.DEFAULT_BEM_SETTING;
        }
        return __assign({}, helpers_1.DEFAULT_BEM_SETTING, this.context.BEM_Setting);
    };
    BEMNode.prototype.replaceModulesStyles = function (classNames) {
        var _this = this;
        if (!this.context.BEM_StylesObject) {
            return classNames;
        }
        return classNames.map(function (className) { return _this.context.BEM_StylesObject[className] || className; });
    };
    // @ts-ignore
    BEMNode.prototype.render = function (Component) {
        var className = this.replaceModulesStyles(this.getClassName()).join(' ');
        var _a = this.props, forwardedRef = _a.forwardedRef, props = __rest(_a, ["forwardedRef"]);
        return (React.createElement(Component, __assign({ className: className, forwardedRef: forwardedRef }, helpers_1.cleanUpProps(props)), this.props.children));
    };
    BEMNode.defaultProps = {
        bemName: [],
        bemMod: [],
        className: '',
        bemBlock: null
    };
    BEMNode.propTypes = {
        bemName: helpers_1.PropTypesBemValue,
        bemMod: helpers_1.PropTypesBemValue,
        bemBlock: helpers_1.PropTypesBemValue,
        className: PropTypes.string,
        children: PropTypes.any,
        forwardedRef: PropTypes.func,
    };
    BEMNode.contextTypes = {
        BEM_BlockNames: PropTypes.arrayOf(PropTypes.string),
        BEM_StylesObject: PropTypes.object,
        BEM_Setting: helpers_1.PropTypesBemSetting,
    };
    return BEMNode;
}(React.Component));
exports.BEMNode = BEMNode;
