import * as React from 'react';
import * as PropTypes from 'prop-types';
import { BemValue, BemSetting } from '../domain';
export interface BEMNodeProps {
    bemName: BemValue;
    bemMod: BemValue;
    bemBlock: BemValue;
    className: string;
    children: React.ReactNode;
    forwardedRef: () => HTMLElement | null;
}
export interface BEMNodeContext {
    BEM_BlockNames: string[];
    BEM_StylesObject: {
        [key: string]: string;
    };
    BEM_Setting: BemSetting;
}
export declare class BEMNode extends React.Component<BEMNodeProps, {}, BEMNodeContext> {
    static defaultProps: Partial<BEMNodeProps>;
    static propTypes: {
        [key in keyof BEMNodeProps]: PropTypes.Requireable<any>;
    };
    static contextTypes: {
        [key in keyof BEMNodeContext]: PropTypes.Requireable<any>;
    };
    getMods(): string[];
    getNames(): string[];
    getClassName(): string[];
    getBemSetting(): BemSetting;
    replaceModulesStyles(classNames: string[]): string[];
    render(Component: typeof React.Component): JSX.Element;
}
