import * as React from 'react';
export declare function bemBlockDecorator(Component: typeof React.Component): {
    new (props: Readonly<import("./BEMNode").BEMNodeProps>): {
        render(): JSX.Element;
        getChildContext(): import("./BEMBlock").BEMBlockContext;
        getNames(): string[];
        getMods(): string[];
        getClassName(): string[];
        getBemSetting(): import("../domain").BemSetting;
        replaceModulesStyles(classNames: string[]): string[];
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("./BEMNode").BEMNodeProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callBack?: () => void): void;
        readonly props: Readonly<import("./BEMNode").BEMNodeProps> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("./BEMNode").BEMNodeProps>, prevState: Readonly<{}>): import("./BEMNode").BEMNodeContext;
        componentDidUpdate?(prevProps: Readonly<import("./BEMNode").BEMNodeProps>, prevState: Readonly<{}>, snapshot?: import("./BEMNode").BEMNodeContext): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: import("./BEMNode").BEMNodeProps, context?: any): {
        render(): JSX.Element;
        getChildContext(): import("./BEMBlock").BEMBlockContext;
        getNames(): string[];
        getMods(): string[];
        getClassName(): string[];
        getBemSetting(): import("../domain").BemSetting;
        replaceModulesStyles(classNames: string[]): string[];
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("./BEMNode").BEMNodeProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callBack?: () => void): void;
        readonly props: Readonly<import("./BEMNode").BEMNodeProps> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("./BEMNode").BEMNodeProps>, prevState: Readonly<{}>): import("./BEMNode").BEMNodeContext;
        componentDidUpdate?(prevProps: Readonly<import("./BEMNode").BEMNodeProps>, prevState: Readonly<{}>, snapshot?: import("./BEMNode").BEMNodeContext): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): void;
    };
    childContextTypes: {
        BEM_BlockNames: import("prop-types").Requireable<any>;
    };
    defaultProps: Partial<import("./BEMNode").BEMNodeProps>;
    propTypes: {
        bemName: import("prop-types").Requireable<any>;
        bemMod: import("prop-types").Requireable<any>;
        bemBlock: import("prop-types").Requireable<any>;
        className: import("prop-types").Requireable<any>;
        children: import("prop-types").Requireable<any>;
        forwardedRef: import("prop-types").Requireable<any>;
    };
    contextTypes: {
        BEM_BlockNames: import("prop-types").Requireable<any>;
        BEM_StylesObject: import("prop-types").Requireable<any>;
        BEM_Setting: import("prop-types").Requireable<any>;
    };
    contextType?: React.Context<any>;
};
export declare function bemElementDecorator(Component: typeof React.Component): {
    new (props: Readonly<import("./BEMNode").BEMNodeProps>): {
        render(): JSX.Element;
        getNames(): string[];
        getMods(): string[];
        getClassName(): string[];
        getBemSetting(): import("../domain").BemSetting;
        replaceModulesStyles(classNames: string[]): string[];
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("./BEMNode").BEMNodeProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callBack?: () => void): void;
        readonly props: Readonly<import("./BEMNode").BEMNodeProps> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("./BEMNode").BEMNodeProps>, prevState: Readonly<{}>): import("./BEMNode").BEMNodeContext;
        componentDidUpdate?(prevProps: Readonly<import("./BEMNode").BEMNodeProps>, prevState: Readonly<{}>, snapshot?: import("./BEMNode").BEMNodeContext): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): void;
    };
    new (props: import("./BEMNode").BEMNodeProps, context?: any): {
        render(): JSX.Element;
        getNames(): string[];
        getMods(): string[];
        getClassName(): string[];
        getBemSetting(): import("../domain").BemSetting;
        replaceModulesStyles(classNames: string[]): string[];
        context: any;
        setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<import("./BEMNode").BEMNodeProps>) => {} | Pick<{}, K>) | Pick<{}, K>, callback?: () => void): void;
        forceUpdate(callBack?: () => void): void;
        readonly props: Readonly<import("./BEMNode").BEMNodeProps> & Readonly<{
            children?: React.ReactNode;
        }>;
        state: Readonly<{}>;
        refs: {
            [key: string]: React.ReactInstance;
        };
        componentDidMount?(): void;
        shouldComponentUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): boolean;
        componentWillUnmount?(): void;
        componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
        getSnapshotBeforeUpdate?(prevProps: Readonly<import("./BEMNode").BEMNodeProps>, prevState: Readonly<{}>): import("./BEMNode").BEMNodeContext;
        componentDidUpdate?(prevProps: Readonly<import("./BEMNode").BEMNodeProps>, prevState: Readonly<{}>, snapshot?: import("./BEMNode").BEMNodeContext): void;
        componentWillMount?(): void;
        UNSAFE_componentWillMount?(): void;
        componentWillReceiveProps?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextContext: any): void;
        UNSAFE_componentWillReceiveProps?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextContext: any): void;
        componentWillUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): void;
        UNSAFE_componentWillUpdate?(nextProps: Readonly<import("./BEMNode").BEMNodeProps>, nextState: Readonly<{}>, nextContext: any): void;
    };
    defaultProps: Partial<import("./BEMNode").BEMNodeProps>;
    propTypes: {
        bemName: import("prop-types").Requireable<any>;
        bemMod: import("prop-types").Requireable<any>;
        bemBlock: import("prop-types").Requireable<any>;
        className: import("prop-types").Requireable<any>;
        children: import("prop-types").Requireable<any>;
        forwardedRef: import("prop-types").Requireable<any>;
    };
    contextTypes: {
        BEM_BlockNames: import("prop-types").Requireable<any>;
        BEM_StylesObject: import("prop-types").Requireable<any>;
        BEM_Setting: import("prop-types").Requireable<any>;
    };
    contextType?: React.Context<any>;
};
