import { BemValue, BemInfo, BemSetting } from './domain';
/**
 * Default setting
 */
export declare const DEFAULT_BEM_SETTING: BemSetting;
/**
 * Create class name with modifiers
 * @param {string} className
 * @param {string[]} modifiers
 * @param {object} setting
 * @return {string[]}
 */
export declare function addModifiersToClassName(className: string, modifiers?: string[], setting?: BemSetting): string[];
/**
 * Test bemInfo values by blockName and elementName
 * @param {object} bemInfo
 * @param {string} block
 * @param {string} element
 * @return {bool}
 */
export declare function checkBemInfoCondition(bemInfo: BemInfo, block: string, element?: string): boolean;
/**
 * Create class name with modifiers
 * @param {string} className
 * @param {object} setting
 * @return {object}
 */
export declare function getStringBemInfo(className: string, setting?: BemSetting): BemInfo;
/**
 * Converts many possible values to one format.
 * return empty array if bemValue is invalid
 * @param {string|object|string[]} bemValue
 * @return {string[]}
 */
export declare function convertBemValueToArray(bemValue: BemValue): string[];
/**
 * Delete from props many key before add to Html Element
 * @param {object} props
 * @return {object}
 */
declare type ObjectWithAnyValue = {
    [key: string]: any;
};
export declare function cleanUpProps(props: ObjectWithAnyValue): ObjectWithAnyValue;
/**
 * Validator for bem value
 */
export declare const PropTypesBemValue: any;
/**
 * Validator for bem setting
 */
export declare const PropTypesBemSetting: any;
export {};
